
module basic_microcode_store (output reg [0:7] a, output reg [0:7] b, output reg [0:3] alufunc, output reg [0:0] cin, output reg [0:1] display, output reg [0:22] all,
                        input wen, input clk, input [0:3] addr, input [0:22] wdata);
    reg [0:22] mem [0:15];
    initial begin
        mem[0] =  23'b10000000000000000000000;
        mem[1] =  23'b01000000000000000000000;
        mem[2] =  23'b00100000000000000000000;
        mem[3] =  23'b00010000000000000000000;
        mem[4] =  23'b00001000000000000000000;
	    mem[5] =  23'b00000100000000000000000;
	    mem[6] =  23'b00000010000000000000000;
	    mem[7] =  23'b00000001000000000000000;
	    mem[8] =  23'b00000010000000000000000;
	    mem[9] =  23'b00000100000000000000000;
	    mem[10] = 23'b00001000000000000000000;
	    mem[11] = 23'b00010000000000000000000;
	    mem[12] = 23'b00100000000000000000000;
	    mem[13] = 23'b01000000000000000000000;
	    mem[14] = 23'b10000000000000000000000;
	    mem[15] = 23'b11111111000000000000000;
        //mem[16] = 23'b00001100000100011111000;
        //mem[17] = 23'b00001100000100011111000;
        //mem[18] = 23'b00001100000100011111000;
        //mem[19] = 23'b00001100000100011111000;
        //mem[20] = 23'b00001100000100011111000;
        //mem[21] = 23'b00001100000100011111000;
        //mem[22] = 23'b00001100000100011111000;
        //mem[23] = 23'b00001100000100011111000;
        //mem[24] = 23'b00001100000100011111000;
        //mem[25] = 23'b00001100000100011111000;
        //mem[26] = 23'b00001100000100011111000;
        //mem[27] = 23'b00001100000100011111000;
        /*all = 23'h000000;
        a = all[0:7];
        b = all[8:15];
        alufunc = all[16:19];
        cin = all[20];
        display = 2'b00;*/
    end
    always @(posedge clk) begin
        if (wen) mem[addr] <= wdata;
        all <= mem[addr];
        a <= mem[addr][0:7];
        b <= mem[addr][8:15];
        alufunc <= mem[addr][16:19];
        cin <= mem[addr][20];
        display <= 2'b00;
    end  
endmodule
